/*
 * The Clear BSD License
 * Copyright (c) 2016, Freescale Semiconductor, Inc.
 * Copyright 2016-2017 NXP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 * that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Pins v3.0
processor: MIMXRT1021xxxxx
package_id: MIMXRT1021DAG5A
mcu_data: i_mx_1_0
processor_version: 0.0.3
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */

#include "fsl_common.h"
#include "fsl_iomuxc.h"
#include "board.h"
#include "pin_mux.h"
#include "fsl_gpio.h"

/*FUNCTION**********************************************************************
 * 
 * Function Name : BOARD_InitBootPins
 * Description   : Calls initialization functions.
 * 
 *END**************************************************************************/
void BOARD_InitBootPins(void) {
    BOARD_InitPins();
}

/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitPins:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: L14, peripheral: LPUART1, signal: RX, pin_signal: GPIO_AD_B0_13, slew_rate: Slow, software_input_on: Disable, open_drain: Disable, speed: MHZ_100, drive_strength: R0_6,
    pull_keeper_select: Keeper, pull_keeper_enable: Enable, pull_up_down_config: Pull_Down_100K_Ohm, hysteresis_enable: Disable}
  - {pin_num: K14, peripheral: LPUART1, signal: TX, pin_signal: GPIO_AD_B0_12, slew_rate: Slow, software_input_on: Disable, open_drain: Disable, speed: MHZ_100, drive_strength: R0_6,
    pull_keeper_select: Keeper, pull_keeper_enable: Enable, pull_up_down_config: Pull_Down_100K_Ohm, hysteresis_enable: Disable}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */

/*FUNCTION**********************************************************************
 *
 * Function Name : BOARD_InitPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 *END**************************************************************************/
void BOARD_InitPins(void) {
  CLOCK_EnableClock(kCLOCK_Iomuxc);          /* iomuxc clock (iomuxc_clk_enable): 0x03u */

  IOMUXC_SetPinMux(
      IOMUXC_GPIO_AD_B0_06_LPUART1_TX,        /* GPIO_AD_B0_06 is configured as LPUART1_TX */
      0U);                                    /* Software Input On Field: Input Path is determined by functionality */
  IOMUXC_SetPinMux(
      IOMUXC_GPIO_AD_B0_07_LPUART1_RX,        /* GPIO_AD_B0_07 is configured as LPUART1_RX */
      0U);                                    /* Software Input On Field: Input Path is determined by functionality */
  IOMUXC_SetPinConfig(
      IOMUXC_GPIO_AD_B0_06_LPUART1_TX,        /* GPIO_AD_B0_06 PAD functional properties : */
      0x10B0u);                               /* Slew Rate Field: Slow Slew Rate
                                                 Drive Strength Field: R0/6
                                                 Speed Field: medium(100MHz)
                                                 Open Drain Enable Field: Open Drain Disabled
                                                 Pull / Keep Enable Field: Pull/Keeper Enabled
                                                 Pull / Keep Select Field: Keeper
                                                 Pull Up / Down Config. Field: 100K Ohm Pull Down
                                                 Hyst. Enable Field: Hysteresis Disabled */
  IOMUXC_SetPinConfig(
      IOMUXC_GPIO_AD_B0_07_LPUART1_RX,        /* GPIO_AD_B0_07 PAD functional properties : */
      0x10B0u);                               /* Slew Rate Field: Slow Slew Rate
                                                 Drive Strength Field: R0/6
                                                 Speed Field: medium(100MHz)
                                                 Open Drain Enable Field: Open Drain Disabled
                                                 Pull / Keep Enable Field: Pull/Keeper Enabled
                                                 Pull / Keep Select Field: Keeper
                                                 Pull Up / Down Config. Field: 100K Ohm Pull Down
                                                 Hyst. Enable Field: Hysteresis Disabled */
   
    /* Cameara pin mux and pad configurations. */
    IOMUXC_SetPinMux(IOMUXC_GPIO_SD_B1_03_CCM_CLKO2, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_04_FLEXIO1_FLEXIO16, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_05_GPIO2_IO05, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_06_FLEXIO1_FLEXIO18, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_07_GPIO2_IO07, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_16_GPIO2_IO16, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_SD_B1_03_CCM_CLKO2, 0U);   
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_20_FLEXIO1_FLEXIO24, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_21_FLEXIO1_FLEXIO25, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_22_FLEXIO1_FLEXIO26, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_23_FLEXIO1_FLEXIO27, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_24_FLEXIO1_FLEXIO28, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_25_FLEXIO1_FLEXIO29, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_26_FLEXIO1_FLEXIO30, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_27_FLEXIO1_FLEXIO31, 0U);

    IOMUXC_SetPinConfig(IOMUXC_GPIO_SD_B1_03_CCM_CLKO2, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_04_FLEXIO1_FLEXIO16, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_05_GPIO2_IO05, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_06_FLEXIO1_FLEXIO18, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_07_GPIO2_IO07, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_16_GPIO2_IO16, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_SD_B1_03_CCM_CLKO2, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_20_FLEXIO1_FLEXIO24, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_21_FLEXIO1_FLEXIO25, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_22_FLEXIO1_FLEXIO26, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_23_FLEXIO1_FLEXIO27, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_24_FLEXIO1_FLEXIO28, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_25_FLEXIO1_FLEXIO29, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_26_FLEXIO1_FLEXIO30, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_27_FLEXIO1_FLEXIO31, 0x10B0u);
    
    /* LCD and touch panel pin mux and pad configurations. */
    IOMUXC_SetPinMux(IOMUXC_GPIO_AD_B1_12_LPSPI3_SCK, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_AD_B1_13_LPSPI3_PCS0, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_AD_B1_14_LPSPI3_SDO, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_AD_B1_15_LPSPI3_SDI, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_34_GPIO3_IO02, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_SD_B1_00_GPIO3_IO20, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_SD_B1_01_GPIO3_IO21, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_SD_B1_02_GPIO3_IO22, 0U);

    IOMUXC_SetPinConfig(IOMUXC_GPIO_AD_B1_12_LPSPI3_SCK, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_AD_B1_13_LPSPI3_PCS0, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_AD_B1_14_LPSPI3_SDO, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_AD_B1_15_LPSPI3_SDI, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_34_GPIO3_IO02, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_SD_B1_00_GPIO3_IO20, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_SD_B1_01_GPIO3_IO21, 0x10B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_SD_B1_02_GPIO3_IO22, 0x10B0u);
}

void BOARD_Init_I2C_Pins(void) {
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_18_LPI2C2_SDA, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_19_LPI2C2_SCL, 0U);
    
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_18_LPI2C2_SDA, 0xD8B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_19_LPI2C2_SCL, 0xD8B0u);
}

void BOARD_Init_I2C_GPIO_Pins(void) {
    gpio_pin_config_t gpio_pin_config ={
        .direction = kGPIO_DigitalOutput,
        .outputLogic = 1U,
        .interruptMode = kGPIO_NoIntmode
    };

    GPIO_PinInit(BOARD_I2C_SCL_GPIO_BASE, BOARD_I2C_SCL_PIN_INDEX, &gpio_pin_config);
    GPIO_PinInit(BOARD_I2C_SDA_GPIO_BASE, BOARD_I2C_SDA_PIN_INDEX, &gpio_pin_config);
    
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_18_GPIO2_IO18, 0U);
    IOMUXC_SetPinMux(IOMUXC_GPIO_EMC_19_GPIO2_IO19, 0U);
    
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_18_GPIO2_IO18, 0xF8B0u);
    IOMUXC_SetPinConfig(IOMUXC_GPIO_EMC_19_GPIO2_IO19, 0xF8B0u);
}
/*******************************************************************************
 * EOF
 ******************************************************************************/
